-- thank cremor for all the work done on updating the rotation for wod changes

--From: http://www.mmo-champion.com/threads/2032993-7-0-Retribution-Paladin-Guide-and-Discussion

--The default Priority list should look like this:
--1	Judgment	Keep Judgment on cooldown @4+ Holy Power and/or DP procs.***
--2	Templar's Verdict	Cast Templar's Verdict with Judgment up and @5 Holy Power.
--3	Crusader Strike/Zeal	Cast Crusader Strike or Zeal if @2 charges. Generates 1 Holy Power.
--4	Blade of Justice	Cast Blade of Justice/T4 talent @3 or less Holy Power. Generates 2 Holy Power.
--5	The Fires of Justice	Cast the Fires of Justice Crusader Strike if @2 charges. Generates 1 Holy Power.
--6	Templar's Verdict	Cast with Judgment up and @4 Holy Power or to spend a Fires of Justice proc regardless of your current Holy Power.
--7	Consecration	Cast Consecration if talented.
--8	Crusader Strike/Zeal	Cast Crusader Strike or Zeal if @1 charge. Generates 1 Holy Power.
--9	Blinding Light	Cast Blinding Light if talented and there is nothing else to cast.
--10	Templar's Verdict	Cast with Judgment up and @3 Holy Power when there is nothing else to cast.

--j tv5 cs2 boj tv_tfoj cons cs bl tv

--Divine Purpose priority:

--1	Judgment	Keep Judgment on cooldown @4+ Holy Power and/or DP procs.***
--2	Justicar's Vengeance	Cast Justicar's Vengeance @5 Holy Power with Divine Purpose proc and Judgment up. Or if DP is about to fade.
--3	Templar's Verdict	Cast Templar's Verdict with Judgment up and @5 Holy Power.
--4	Crusader Strike/Zeal	Cast Crusader Strike or Zeal if @2 charges. Generates 1 Holy Power.
--5	Blade of Justice	Cast Blade of Justice/T4 talent @3 or less Holy Power. Generates 2 Holy Power.
--6	The Fires of Justice	Cast the Fires of Justice Crusader Strike if @2 charges. Generates 1 Holy Power.
--7	Justicar's Vengeance	Cast Justicar's Vengeance with Divine Purpose proc and Judgment up. Higher priority than spending last charge of CS/Zeal.
--8	Templar's Verdict	Cast with Judgment up and @4 Holy Power or to spend a Fires of Justice proc regardless of your current Holy Power.
--9	Consecration	Cast Consecration if talented.
--10	Crusader Strike/Zeal	Cast Crusader Strike or Zeal if @1 charge. Generates 1 Holy Power.
--11	Blinding Light	Cast Blinding Light if talented and there is nothing else to cast.
--12	Templar's Verdict	Cast with Judgment up and @3 Holy Power when there is nothing else to cast.

--j jv5 tv5 cs2 boj jv tv_tfoj cons cs bl tv



-- don't load if class is wrong
local _, class = UnitClass("player")
if class ~= "PALADIN" then return end

local _, xmod = ...

xmod.retmodule = {}
xmod = xmod.retmodule

local qTaint = true -- will force queue check

-- thanks cremor
local GetTime, GetSpellCooldown, UnitBuff, UnitAura, UnitPower, UnitSpellHaste, UnitHealth, UnitHealthMax, GetActiveSpecGroup, GetTalentInfoByID, GetGlyphSocketInfo, IsUsableSpell, GetShapeshiftForm, max, min, SPELL_POWER_HOLY_POWER =
GetTime, GetSpellCooldown, UnitBuff, UnitAura, UnitPower, UnitSpellHaste, UnitHealth, UnitHealthMax, GetActiveSpecGroup, GetTalentInfoByID, GetGlyphSocketInfo, IsUsableSpell, GetShapeshiftForm, max, min, SPELL_POWER_HOLY_POWER
local db

-- debug if clcInfo detected
local debug
if clcInfo then debug = clcInfo.debug end

xmod.version = 7000001
xmod.defaults = {
	version = xmod.version,
	prio = "j jv5 tv5 cs2 boj jv tv_tfoj cons cs bl tv",
	rangePerSkill = false,
	howclash = 0, -- priority time for hammer of wrath
	csclash = 0, -- priority time for cs
	exoclash = 0, -- priority time for exorcism
	ssduration = 0, -- minimum duration on ss buff before suggesting refresh
}

-- @defines
--------------------------------------------------------------------------------
local idGCD = 85256 -- tv for gcd

-- spells
local idTemplarsVerdict = 85256
local idCrusaderStrike = 35395
local idJudgement = 20271
local idConsecration = 205228
local idBlindingLight = 115750
local idJusticarsVengeance = 215661

-- tier 4
local idBladeOfJustice = 184575
--local idVirtuesBlade = 202271
--local idBladeOfWrath = 202270
--local idDivineHammer = 198034


--local dsId					= 53385		-- divine storm
--local esId					= 114157	-- execution sentence

-- buffs
local ln_buff_TheFiresOfJustice = GetSpellInfo(209785)
local ln_buff_DivinePurpose = GetSpellInfo(223819)

-- debuffs
local ln_debuff_Judgement = GetSpellInfo(197277)

-- status vars
local s1, s2
local s_ctime, s_otime, s_gcd, s_hp, s_dp, s_aw, s_ss, s_dc, s_fv, s_bc, s_haste, s_in_execute_range
local s_CrusaderStrikeCharges = 0
local s_buff_DivinePurpose, s_buff_TheFiresOfJustice
local s_debuff_Judgement

local talent_DivinePurpose = false

-- the queue
local qn = {} -- normal queue
local q -- working queue

local function GetCooldown(id)
	local start, duration = GetSpellCooldown(id)
	if start == nil then return 100 end
	local cd = start + duration - s_ctime - s_gcd
	if cd < 0 then return 0 end
	return cd
end

local function GetCSData()
	local charges, maxCharges, start, duration = GetSpellCharges(idCrusaderStrike)
	if (charges >= 2) then
		return 0, 2
	end

	if start == nil then
		return 100, charges
	end
	local cd = start + duration - s_ctime - s_gcd
	if cd < 0 then
		return 0, min(2, charges + 1)
	end

	return cd, charges
end

-- actions ---------------------------------------------------------------------
local actions = {
	--1	Judgment	Keep Judgment on cooldown @4+ Holy Power and/or DP procs.***
	j = {
		id = idJudgement,
		GetCD = function()
			if s1 ~= idJudgement then
				return GetCooldown(idJudgement)
			end
			return 100 -- lazy stuff
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5
			s_debuff_Judgement = 8
		end,
		info = "Judgement",
	},
	--2	Justicar's Vengeance	Cast Justicar's Vengeance @5 Holy Power with Divine Purpose proc and Judgment up. Or if DP is about to fade.
	jv5 = {
		id = idJusticarsVengeance,
		GetCD = function()
			if ((s1 ~= idJusticarsVengeance) and (s_buff_DivinePurpose > 0) and ((s_hp == 5) or (s_buff_DivinePurpose < s_gcd))) then
				return 0
			end
			return 100
		end,
		UpdateStatus = function()
		end,
		info = "Justicar's Vengeance @5 Holy Power with DP and Judgement up or if DP is about to fade",
		reqTalent = 22595,
	},
	--2	Justicar's Vengeance	Cast Justicar's Vengeance @5 Holy Power with Divine Purpose proc and Judgment up. Or if DP is about to fade.
	jv = {
		id = idJusticarsVengeance,
		GetCD = function()
			if ((s1 ~= idJusticarsVengeance) and (s_buff_DivinePurpose > 0)) then
				return 0
			end
			return 100
		end,
		UpdateStatus = function()
		end,
		info = "Justicar's Vengeance with DP and Judgement up",
		reqTalent = 22595,
	},
	--2	Templar's Verdict	Cast Templar's Verdict with Judgment up and @5 Holy Power.
	tv5 = {
		id = idTemplarsVerdict,
		GetCD = function()
			if ((s_debuff_Judgement > 0) and (s_hp >= 5)) then
				return 0
			end
			return 100
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5
			if (s_buff_DivinePurpose > 0) then
				s_buff_DivinePurpose = 0
			else
				s_hp = max(0, s_hp - 3)
			end
		end,
		info = "Templar's Verdict or Final Verdict with HP >= 5",
	},
	--3	Crusader Strike/Zeal	Cast Crusader Strike or Zeal if @2 charges. Generates 1 Holy Power.
	cs2 = {
		id = idCrusaderStrike,
		GetCD = function()
			if (s_CrusaderStrikeCharges == 2) then
				return 0
			end
			return 100
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5
			s_hp = min(5, s_hp + 1)
			s_CrusaderStrikeCharges = max(0, s_CrusaderStrikeCharges - 1)
		end,
		info = "Crusader Strike stacks = 2",
	},
	--4	Blade of Justice	Cast Blade of Justice/T4 talent @3 or less Holy Power. Generates 2 Holy Power.
	boj = {
		id = idBladeOfJustice,
		GetCD = function()
			if ((s1 ~= idBladeOfJustice) and (s_hp <= 3)) then
				return GetCooldown(idBladeOfJustice)
			end
			return 100
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5
			s_hp = min(5, s_hp + 2)
		end,
		info = "Blade of Justice",
	},
	--5	The Fires of Justice	Cast the Fires of Justice Crusader Strike if @2 charges. Generates 1 Holy Power.
	--6	Templar's Verdict	Cast with Judgment up and @4 Holy Power or to spend a Fires of Justice proc regardless of your current Holy Power.
	tv_tfoj = {
		id = idTemplarsVerdict,
		GetCD = function()
			if ((s_debuff_Judgement > 0) and ((s_hp >= 4) or (s_buff_TheFiresOfJustice > 0))) then
				return 0
			end
			return 100
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5
			if (s_buff_DivinePurpose > 0) then
				s_buff_DivinePurpose = 0
			else
				s_hp = max(0, s_hp - 2)
			end
		end,
		info = "Templar's Verdict with The Fires of Justice proc",
	},
	--7	Consecration	Cast Consecration if talented.
	cons = {
		id = idConsecration,
		GetCD = function()
			if (s1 ~= idConsecration) then
				return GetCooldown(idConsecration) + 0.7
			end
			return 100
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
		end,
		info = "nothing to see here",
		reqTalent = 22175,
	},
	--8	Crusader Strike/Zeal	Cast Crusader Strike or Zeal if @1 charge. Generates 1 Holy Power.
	cs = {
		id = idCrusaderStrike,
		GetCD = function()
			local cd, charges = GetCSData()
			if (charges == 1) then
				return 0
			end
			return cd + 0.5
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5
			s_hp = min(5, s_hp + 1)
			s_CrusaderStrikeCharges = max(0, s_CrusaderStrikeCharges - 1)
		end,
		info = "Crusader Strike",
	},
	--9	Blinding Light	Cast Blinding Light if talented and there is nothing else to cast.
	bl = {
		id = idBlindingLight,
		GetCD = function()
			if (s1 ~= idBlindingLight) then
				return GetCooldown(idBlindingLight) + 1
			end
			return 100
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
		end,
		info = "nothing to see here",
		reqTalent = 21811,
	},
	--10	Templar's Verdict	Cast with Judgment up and @3 Holy Power when there is nothing else to cast.
	tv = {
		id = idTemplarsVerdict,
		GetCD = function()
			if ((s_debuff_Judgement > 0) and (s_hp >= 3)) then
				return 0
			end
			return 100
		end,
		UpdateStatus = function()
			s_ctime = s_ctime + s_gcd + 1.5
			if (s_buff_DivinePurpose > 0) then
				s_buff_DivinePurpose = 0
			else
				s_hp = max(0, s_hp - 3)
			end
		end,
		info = "Templar's Verdict HP >= 3 and Judgement debuff up",
	},
--	cs_tfoj = {
--		id = idTemplarsVerdict,
--		GetCD = function()
--			return 100
--		end,
--		UpdateStatus = function()
--		end,
--		info = "nothing to see here",
--	},
	--	tv4_aw = {
	--		id = idTemplarsVerdict,
	--		GetCD = function()
	--			if ( ((s_hp >= 4) or (s_hp >= 3 and s_ha > 0)) and (s_aw > 0) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			if s_dp > 0 then
	--				s_dp = 0
	--			else
	--				s_hp = max(0, s_hp - 3)
	--			end
	--			if s_fv_talent then
	--				s_fv = 30
	--			end
	--		end,
	--		info = "Templar's Verdict or Final Verdict with HP >= 4 and Avenging Wrath up",
	--	},
	--	tv3 = {
	--		id = idTemplarsVerdict,
	--		GetCD = function()
	--			if s_hp >= 3 then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			if s_dp > 0 then
	--				s_dp = 0
	--			else
	--				s_hp = max(0, s_hp - 3)
	--			end
	--			if s_fv_talent then
	--				s_fv = 30
	--			end
	--		end,
	--		info = "Templar's Verdict or Final Verdict with HP >= 3",
	--	},
	--	tv_dp = {
	--		id = idTemplarsVerdict,
	--		GetCD = function()
	--			if s_dp > 0.1 then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dp = 0
	--			if s_fv_talent then
	--				s_fv = 30
	--			end
	--		end,
	--		info = "Templar's Verdict or Final Verdict when Divine Purpose procs"
	--	},
	--	tv_dp_4s = {
	--		id = idTemplarsVerdict,
	--		GetCD = function()
	--			if (s_dp > 0.1) and (s_dp < 4) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dp = 0
	--			if s_fv_talent then
	--				s_fv = 30
	--			end
	--		end,
	--		info = "Templar's Verdict or Final Verdict with Divine Purpose < 4s remaining"
	--	},
	--	tv_aw = {
	--		id = idTemplarsVerdict,
	--		GetCD = function()
	--			if ((s_hp >= 3) or (s_dp > 0.1)) and (s_aw > 0) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			if s_dp > 0 then
	--				s_dp = 0
	--			else
	--				s_hp = max(0, s_hp - 3)
	--			end
	--			if s_fv_talent then
	--				s_fv = 30
	--			end
	--		end,
	--		info = "Templar's Verdict or Final Verdict with HP >= 3 or Divine Purpose during Avenging Wrath",
	--	},
	--	tv_aw_exec = {
	--		id = idTemplarsVerdict,
	--		GetCD = function()
	--			if ((s_hp >= 3) or (s_dp > 0.1)) and (s_aw > 0 or s_in_execute_range) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			if s_dp > 0 then
	--				s_dp = 0
	--			else
	--				s_hp = max(0, s_hp - 3)
	--			end
	--			if s_fv_talent then
	--				s_fv = 30
	--			end
	--		end,
	--		info = "Templar's Verdict or Final Verdict with HP >= 3 or Divine Purpose during Avenging Wrath or execute range",
	--	},
	--	fv = {
	--		id = fvId,
	--		GetCD = function()
	--			if s_hp >= 3 then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			if s_dp > 0 then
	--				s_dp = 0
	--			else
	--				s_hp = max(0, s_hp - 3)
	--			end
	--			s_fv = 30
	--		end,
	--		info = "Final Verdict with HP >= 3",
	--		reqTalent = 21672,
	--	},
	--	fv_dp = {
	--		id = fvId,
	--		GetCD = function()
	--			if s_dp > 0.1 then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dp = 0
	--			s_fv = 30
	--		end,
	--		info = "Final Verdict when Divine Purpose procs",
	--		reqTalent = 21672,
	--	},
	--	eds = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( s_dc > 0.1 ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm",
	--	},
	--	ds5 = {
	--		id = dsId,
	--		GetCD = function()
	--			if s_hp >= 5 then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			s_hp = s_hp - 3
	--		end,
	--		info = "Divine Storm with 5HP and no buff/proc",
	--	},
	--	eds5 = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( (s_dc > 0.1) and (s_hp >= 5) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm with 5HP",
	--	},
	--	eds_aw = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( (s_dc > 0.1) and (s_aw > 0) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm during Avenging Wrath",
	--	},
	--	eds_aw_exec = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( (s_dc > 0.1) and (s_aw > 0 or s_in_execute_range) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm during Avenging Wrath or execute range",
	--	},
	--	eds_4s = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( (s_dc > 0.1) and (s_dc < 4) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm < 4s remaining",
	--	},
	--	eds_fv = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( ( s_dc > 0.1 ) and (s_fv > 0.1) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm with Final Verdict buff",
	--		reqTalent = 21672,
	--	},
	--	eds5_fv = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( (s_dc > 0.1) and (s_fv > 0.1) and (s_hp >= 5) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm with Final Verdict buff and 5HP",
	--		reqTalent = 21672,
	--	},
	--	eds_fv_aw = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( (s_dc > 0.1) and (s_fv > 0.1) and (s_aw > 0) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm with Final Verdict buff during Avenging Wrath",
	--		reqTalent = 21672,
	--	},
	--	eds_fv_aw_exec = {
	--		id = dsId,
	--		GetCD = function()
	--			if ( (s_dc > 0.1) and (s_fv > 0.1) and (s_aw > 0 or s_in_execute_range) ) then return 0 end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			s_dc = 0
	--			s_fv = 0
	--			-- Using EDS should not consume DP
	--		end,
	--		info = "Empowered Divine Storm with Final Verdict buff during Avenging Wrath or execute range",
	--		reqTalent = 21672,
	--	},
	--	exo = {
	--		id = s_exoId,
	--		GetCD = function()
	--			if s1 == s_exoId then
	--				return 100 -- lazy stuff
	--			else
	--				return max(0, GetCooldown(s_exoId) - db.exoclash)
	--			end
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--			if (s_ha > 0) or (s_bc > 0) then
	--				s_hp = min(5, s_hp + 3)
	--			else
	--				s_hp = min(5, s_hp + 1)
	--			end
	--			s_bc = 0
	--		end,
	--		info = "Exorcism",
	--	},
	--	exo_aw = {
	--		id = s_exoId,
	--		GetCD = function()
	--			if (s1 ~= s_exoId) and (s_aw > 0) then
	--				return max(0, GetCooldown(s_exoId) - db.exoclash)
	--			end
	--			return 100 -- lazy stuff
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--			if (s_ha > 0) or (s_bc > 0) then
	--				s_hp = min(5, s_hp + 3)
	--			else
	--				s_hp = min(5, s_hp + 1)
	--			end
	--			s_bc = 0
	--		end,
	--		info = "Exorcism during Avenging Wrath",
	--	},
	--	exo_bc = {
	--		id = s_exoId,
	--		GetCD = function()
	--			if (s1 ~= s_exoId) and (s_hp <= 2) and (s_bc > 0.1) then
	--				return max(0, GetCooldown(s_exoId) - db.exoclash)
	--			end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--			s_hp = min(5, s_hp + 3)
	--			s_bc = 0
	--		end,
	--		info = "Exorcism with Blazing Contempt (T17 4piece bonus) buff",
	--	},
	--	how = {
	--		id = howId,
	--		GetCD = function()
	--			if (s1 ~= howId) and IsUsableSpell(howId) then
	--				return max(0, GetCooldown(howId) - db.howclash)
	--			end
	--			return 100 -- lazy stuff
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--			if s_ha > 0 then
	--				s_hp = min(5, s_hp + 3)
	--			else
	--				s_hp = min(5, s_hp + 1)
	--			end
	--			if s_4t17_equipped then
	--				s_bc = 20
	--			end
	--		end,
	--		info = "Hammer of Wrath",
	--	},
	--	j_aw = {
	--		id = idJudgement,
	--		GetCD = function()
	--			if ( (s1 ~= idJudgement) and (s_aw > 0) ) then
	--				return GetCooldown(idJudgement)
	--			end
	--			return 100 -- lazy stuff
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5
	--			if s_ha > 0 then
	--				s_hp = min(5, s_hp + 3)
	--			else
	--				s_hp = min(5, s_hp + 1)
	--			end
	--
	--			if (s_emp_talent) then
	--				local sform = s_emp_active
	--				if sform == 1 then
	--					s_mt = 20
	--				elseif sform == 2 then
	--					s_lr = 20
	--				end
	--			end
	--		end,
	--		info = "Judgement during Avenging Wrath",
	--	},
	--	es = {
	--		id = esId,
	--		GetCD = function()
	--			if s1 ~= esId then
	--				return GetCooldown(esId)
	--			end
	--			return 100 -- lazy stuff
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--		end,
	--		info = "Execution Sentence",
	--		reqTalent = 17609,
	--	},
	--	hpr = {
	--		id = hprId,
	--		GetCD = function()
	--			if s1 ~= hprId then
	--				return GetCooldown(hprId)
	--			end
	--			return 100 -- lazy stuff
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--		end,
	--		info = "Holy Prism",
	--		reqTalent = 17605,
	--	},
	--	lh = {
	--		id = lhId,
	--		GetCD = function()
	--			if s1 ~= lhId then
	--				return GetCooldown(lhId)
	--			end
	--			return 100 -- lazy stuff
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--		end,
	--		info = "Light's Hammer",
	--		reqTalent = 17607,
	--	},
	--	ss = {
	--		id = ssId,
	--		GetCD = function()
	--			if s1 ~= ssId and s_ss <= db.ssduration then
	--				return 1.5 / s_haste	-- always return the time it would need to cast the skill so it doesn't overlap any dmg ability
	--			end
	--			return 100 -- lazy stuff
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste + 0.1 -- a bit of extra time to reduce flashing
	--			s_ss = 30
	--		end,
	--		info = "Sacred Shield",
	--		reqTalent = 21098,
	--	},
	--
	--	-- seal swaps
	--	emp_sot_exp = {
	--		id = sotId,
	--		GetCD = function()
	--			if s_emp_active ~= 1 and s_mt < 5 then
	--				return 0
	--			end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--			s_emp_active = 1
	--		end,
	--		info = "Empowered Seals go to Truth when buff has less than 5s left",
	--		reqTalent = 21201,
	--	},
	--	emp_sor_exp = {
	--		id = sorId,
	--		GetCD = function()
	--			if s_emp_active ~= 2 and s_lr < 5 then
	--				return 0
	--			end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--			s_emp_active = 2
	--		end,
	--		info = "Empowered Seals go to Righteousness when buff has less than 5s left",
	--		reqTalent = 21201,
	--	},
	--	emp_sot_return = {
	--		id = sotId,
	--		GetCD = function()
	--			if s_emp_active ~= 1 and s_lr > 10 then
	--				return 0
	--			end
	--			return 100
	--		end,
	--		UpdateStatus = function()
	--			s_ctime = s_ctime + s_gcd + 1.5 / s_haste
	--			s_emp_active = 1
	--		end,
	--		info = "Empowered Seals go back to Truth after casting Righteousness",
	--		reqTalent = 21201,
	--	},
}
--------------------------------------------------------------------------------
local function UpdateQueue()
	-- normal queue
	qn = {}
	for v in string.gmatch(db.prio, "[^ ]+") do
		if actions[v] then
			table.insert(qn, v)
		else
			print("clcretmodule - invalid action:", v)
		end
	end
	db.prio = table.concat(qn, " ")

	-- force reconstruction for q
	qTaint = true
end

local function GetBuff(buff)
	local left = 0
	local _, expires
	_, _, _, _, _, _, expires = UnitBuff("player", buff, nil, "PLAYER")
	if expires then
		left = max(0, expires - s_ctime - s_gcd)
	end
	return left
end

local function GetDebuff(debuff)
	local left = 0
	local _, expires
	_, _, _, _, _, _, expires = UnitDebuff("target", debuff, nil, "PLAYER")
	if expires then
		left = max(0, expires - s_ctime - s_gcd)
	end
	return left
end

-- reads all the interesting data
local function GetStatus()
	-- current time
	s_ctime = GetTime()

	-- gcd value
	local start, duration = GetSpellCooldown(idGCD)
	s_gcd = start + duration - s_ctime
	if s_gcd < 0 then s_gcd = 0 end

	-- the buffs
	--	s_dp = GetBuff(buffDP)
	--	s_ha = GetBuff(buffHA)
	--	s_aw = GetBuff(buffAW)
	--	s_dc = GetBuff(buffDC)
	--	s_bc = GetBuff(buffBC)

	-- the buffs
	if (talent_DivinePurpose) then
		s_buff_DivinePurpose = GetBuff(ln_buff_DivinePurpose)
	else
		s_buff_DivinePurpose = 0
	end
	s_buff_TheFiresOfJustice = GetBuff(ln_buff_TheFiresOfJustice)

	-- the debuffs
	s_debuff_Judgement = GetDebuff(ln_debuff_Judgement)

	-- crusader strike stacks
	local cd, charges = GetCSData()
	s_CrusaderStrikeCharges = charges

	-- client hp and haste
	s_hp = UnitPower("player", SPELL_POWER_HOLY_POWER)
	s_haste = 1 + UnitSpellHaste("player") / 100
end

-- remove all talents not available and present in rotation
-- adjust for modified skills present in rotation
local function GetWorkingQueue()
	q = {}
	local name, selected, available
	for k, v in pairs(qn) do
		-- see if it has a talent requirement
		if actions[v].reqTalent then
			-- see if the talent is activated
			_, name, _, selected, available = GetTalentInfoByID(actions[v].reqTalent, GetActiveSpecGroup())
			if name and selected and available then
				table.insert(q, v)
			end
		else
			table.insert(q, v)
		end
	end
end

local function GetNextAction()
	-- check if working queue needs updated due to glyph talent changes
	if qTaint then
		GetWorkingQueue()
		qTaint = false
	end

	local n = #q

	-- parse once, get cooldowns, return first 0
	for i = 1, n do
		local action = actions[q[i]]
		local cd = action.GetCD()
		if debug and debug.enabled then
			debug:AddBoth(q[i], cd)
		end
		if cd == 0 then
			return action.id, q[i]
		end
		action.cd = cd
	end

	-- parse again, return min cooldown
	local minQ = 1
	local minCd = actions[q[1]].cd
	for i = 2, n do
		local action = actions[q[i]]
		if minCd > action.cd then
			minCd = action.cd
			minQ = i
		end
	end
	return actions[q[minQ]].id, q[minQ]
end

-- exposed functions

-- this function should be called from addons
function xmod.Init()
	db = xmod.db
	UpdateQueue()
end

function xmod.GetActions()
	return actions
end

function xmod.Update()
	UpdateQueue()
end

function xmod.Rotation()
	s1 = nil
	GetStatus()
	if debug and debug.enabled then
		debug:Clear()
		debug:AddBoth("ctime", s_ctime)
		debug:AddBoth("gcd", s_gcd)
		debug:AddBoth("hp", s_hp)
		debug:AddBoth("haste", s_haste)

		debug:AddBoth("dJudgement", s_debuff_Judgement)
		debug:AddBoth("bDivinePurpose", s_buff_DivinePurpose)
		debug:AddBoth("bTFOJ", s_buff_TheFiresOfJustice)
	end
	local action
	s1, action = GetNextAction()
	if debug and debug.enabled then
		debug:AddBoth("s1", action)
		debug:AddBoth("s1Id", s1)
	end
	-- 
	s_otime = s_ctime -- save it so we adjust buffs for next
	actions[action].UpdateStatus()

	s_otime = s_ctime - s_otime

	-- adjust buffs
	s_buff_TheFiresOfJustice = max(0, s_buff_TheFiresOfJustice - s_otime)
	s_buff_DivinePurpose = max(0, s_buff_DivinePurpose - s_otime)

	-- adjust debuffs
	s_debuff_Judgement = max(0, s_debuff_Judgement - s_otime)

	-- crusader strike stacks
	local cd, charges = GetCSData()
	s_CrusaderStrikeCharges = charges
	if (s1 == idCrusaderStrike) then
		s_CrusaderStrikeCharges = s_CrusaderStrikeCharges - 1
	end

	if debug and debug.enabled then
		debug:AddBoth("csc", s_CrusaderStrikeCharges)
	end

	if debug and debug.enabled then
		debug:AddBoth("ctime", s_ctime)
		debug:AddBoth("otime", s_otime)
		debug:AddBoth("gcd", s_gcd)
		debug:AddBoth("hp", s_hp)
		debug:AddBoth("haste", s_haste)
		debug:AddBoth("dJudgement", s_debuff_Judgement)
		debug:AddBoth("bDivinePurpose", s_buff_DivinePurpose)
		debug:AddBoth("bTFOJ", s_buff_TheFiresOfJustice)
	end
	s2, action = GetNextAction()
	if debug and debug.enabled then
		debug:AddBoth("s2", action)
	end

	return s1, s2
end

-- event frame
local ef = CreateFrame("Frame", "clcRetModuleEventFrame") -- event frame
ef:Hide()
local function OnEvent()
	qTaint = true

	-- DivinePurpose talent
	local _, name, _, selected, available = GetTalentInfoByID(22591, GetActiveSpecGroup())
	if name and selected and available then
		talent_DivinePurpose = selected
	end

	-- tier 4 talents
	--local idBladeOfJustice 184575
	--local idVirtuesBlade 202271 / 22375
	--local idBladeOfWrath 202270 / 22182
	--local idDivineHammer 198034 / 22183
	idBladeOfJustice = 184575
	_, name, _, selected, available = GetTalentInfoByID(22375, GetActiveSpecGroup())
	if name and selected and available then
		idBladeOfJustice = 202271
	end
	_, name, _, selected, available = GetTalentInfoByID(22182, GetActiveSpecGroup())
	if name and selected and available then
		idBladeOfJustice = 202270
	end
	_, name, _, selected, available = GetTalentInfoByID(22183, GetActiveSpecGroup())
	if name and selected and available then
		idBladeOfJustice = 198034
	end

	actions['boj'].id = idBladeOfJustice

	
	-- Zeal talent
	_, name, _, selected, available = GetTalentInfoByID(22592, GetActiveSpecGroup())
	if name and selected and available then
		idCrusaderStrike = 217020
	else
		idCrusaderStrike = 35395
	end

	actions['cs2'].id = idCrusaderStrike
	actions['cs'].id = idCrusaderStrike
end


ef:SetScript("OnEvent", OnEvent)
ef:RegisterEvent("PLAYER_ENTERING_WORLD")
ef:RegisterEvent("PLAYER_TALENT_UPDATE")
ef:RegisterEvent("PLAYER_LEVEL_UP")
--ef:RegisterEvent("GLYPH_ADDED")
--ef:RegisterEvent("GLYPH_UPDATED")
--ef:RegisterEvent("GLYPH_REMOVED")
--ef:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
